var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
function isNull(value) {
  return value === null;
}
function isUndefined(value) {
  return value === void 0;
}
var index = {
  install(app, args) {
    var _a;
    const $router = (_a = args.$router) != null ? _a : app.config.globalProperties.$router;
    if (!$router)
      throw new Error("Vue router is not detected");
    $router.beforeEach((to, from) => {
      const { destination } = from.query;
      const { allowRedirect } = to.query;
      return !isUndefined(destination) && !isUndefined(allowRedirect) && destination !== to.fullPath && String(destination) || true;
    });
    $router.beforeResolve((to) => {
      var _a2;
      const { allowRedirect, destination } = to.query;
      if (!isNull(destination) && isUndefined(allowRedirect) && !((_a2 = args.excludes) == null ? void 0 : _a2.some((exclude) => String(destination).match(exclude))))
        return;
      delete to.query.allowRedirect;
      delete to.query.destination;
      return __spreadValues({}, to);
    });
  }
};
export { index as default };
